<template>
  <b-container>
    <div class="mt-2">
      <b-button
        variant="success"
        class="mb-2"
        disabled
        v-if="getServiceResponse > 0"
      >
        <b-spinner small type="grow"></b-spinner>
        Fetching a joke...
      </b-button>
      <b-button v-else variant="success" @click="getRandomJoke()" class="mb-2">
        <div v-if="getServiceResponse">
          <b-spinner small></b-spinner>
          <span class="sr-only">Loading...</span>
        </div>
        <b-icon icon="emoji-sunglasses-fill" aria-hidden="true"></b-icon>
        Get a new joke
      </b-button>

      <b-button
        variant="danger"
        @click="clearLocalStorage()"
        class="float-right"
        v-if="getJokes"
        ><b-icon icon="trash-fill" aria-hidden="true"></b-icon>
        Clear all jokes
      </b-button>
    </div>
    <b-list-group>
      <b-list-group-item v-for="(joke, $index) in getJokes" :key="$index"
        >{{ joke }}
      </b-list-group-item>
    </b-list-group>
  </b-container>
</template>

<script>
import {
  GET_JOKES,
  GET_SERVICE_RESPONSE,
} from "../store/module/appState/getter-types";
import { FETCH_JOKE } from "../store/module/appState/action-types";
import { CLEAR_STATE } from "../store/module/appState/mutation-types";

export default {
  name: "Jokes",
  computed: {
    getJokes() {
      return this.$store.getters[GET_JOKES];
    },
    getServiceResponse() {
      return this.$store.getters[GET_SERVICE_RESPONSE];
    },
  },
  methods: {
    getRandomJoke() {
      this.$store.dispatch(FETCH_JOKE).then(() => {});
    },
    clearLocalStorage() {
      localStorage.clear();
      localStorage.removeItem("jokes");
      this.$store.commit(CLEAR_STATE);
    },
  },
};
</script>

<style></style>
